unit master;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  solit, ExtCtrls, Menus;

type
  Tmasterfrm = class(TForm)
    MainMenu1: TMainMenu;
    File1: TMenuItem;
    New1: TMenuItem;
    N1: TMenuItem;
    exit1: TMenuItem;
    Option1: TMenuItem;
    Setback1: TMenuItem;
    tplayfield1: tplayfield;
    acepile1: tpile;
    acepile2: tpile;
    acepile3: tpile;
    acepile4: tpile;
    cardbase: tpile;
    tpile6: tpile;
    tpile7: tpile;
    tpile8: tpile;
    tpile9: tpile;
    tpile10: tpile;
    freepile1: tpile;
    tpile12: tpile;
    tpile13: tpile;
    tpile14: tpile;
    freepile2: tpile;
    procedure Setback1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure exit1Click(Sender: TObject);
    procedure New1Click(Sender: TObject);
    procedure tplayfield1Start(Sender: TControl);
    procedure tpile6Start(Sender: TControl);
    procedure freepile1Start(Sender: TControl);
    procedure tpile6GetCard(Sender: TControl; cardnumber: Integer;
      cardcursor: tpile);
    procedure tpile6PutCard(Sender: TControl; source: tpile;
      cardnumber: Integer; cardcursor: tpile);
    procedure cardbasePutCard(Sender: TControl; source: tpile;
      cardnumber: Integer; cardcursor: tpile);
    procedure cardbaseGetCard(Sender: TControl; cardnumber: Integer;
      cardcursor: tpile);
    procedure acepile1PutCard(Sender: TControl; source: tpile;
      cardnumber: Integer; cardcursor: tpile);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  masterfrm: Tmasterfrm;

implementation

{$R *.DFM}
var
back:tbacks;
updown:integer;

procedure Tmasterfrm.Setback1Click(Sender: TObject);
begin
if back=cards then back:=dot else back:=tbacks(ord(back)+1);
tplayfield1.setback(back);
end;

procedure Tmasterfrm.FormCreate(Sender: TObject);
begin
back:=dot;
end;

procedure Tmasterfrm.exit1Click(Sender: TObject);
begin
close;
end;

procedure Tmasterfrm.New1Click(Sender: TObject);
begin
tplayfield1.start;
end;

procedure Tmasterfrm.tplayfield1Start(Sender: TControl);
var
i,j:integer;
begin
updown:=0;
tplayfield1.clear;
cardbase.filltile(52,back,true,true,0);
for j:=1 to 4 do
    for i:=0 to cardbase.volume-1 do
        if cardbase[i].card=ace then
           begin
           case j of
           1:acepile1.addcard(cardbase[i]);
           2:acepile2.addcard(cardbase[i]);
           3:acepile3.addcard(cardbase[i]);
           4:acepile4.addcard(cardbase[i]);
           end;
           cardbase.removecard(i);
           break;
           end;
end;

procedure tmasterfrm.tpile6Start(Sender: TControl);
var
i:integer;
begin
for i:=1 to 5  do
    begin
    (sender as tpile).addcard(cardbase.last);
    cardbase.removelast;
    end;
end;

procedure Tmasterfrm.freepile1Start(Sender: TControl);
var
i:integer;
begin
for i:=1 to 4  do
    begin
    (sender as tpile).addcard(cardbase.last);
    cardbase.removelast;
    end;
end;

procedure Tmasterfrm.tpile6GetCard(Sender: TControl; cardnumber: Integer;
  cardcursor: tpile);
begin
if (sender as tpile).volume=0 then exit;
cardcursor.addcard((sender as tpile).last);
(sender as tpile).removelast;
end;

procedure Tmasterfrm.tpile6PutCard(Sender: TControl; source: tpile;
  cardnumber: Integer; cardcursor: tpile);
begin
if ((sender as tpile).volume=0) or
   (abs(ord(cardcursor.last.card)-ord((sender as tpile).last.card))=1) then
   begin
   (sender as tpile).addcard(cardcursor.last);
   cardcursor.removeall;
   end;
end;

procedure Tmasterfrm.cardbasePutCard(Sender: TControl; source: tpile;
  cardnumber: Integer; cardcursor: tpile);
begin
if cardbase.volume=0 then
   begin
   cardbase.addcard(cardcursor.last);
   cardcursor.removeall;
   end;
end;

procedure Tmasterfrm.cardbaseGetCard(Sender: TControl; cardnumber: Integer;
  cardcursor: tpile);
begin
if cardbase.volume=0 then exit;
if (freepile1.volume=0) or (freepile2.volume=0) then
   begin
   cardcursor.addcard(cardbase.last);
   cardbase.removeall;
   end;
end;

procedure Tmasterfrm.acepile1PutCard(Sender: TControl; source: tpile;
  cardnumber: Integer; cardcursor: tpile);
begin
if updown=0 then
   begin
   if (cardcursor.last.card=c2) and (cardcursor.last.suit=(sender as tpile).last.suit) then
      begin
      (sender as tpile).addcard(cardcursor.last);
      cardcursor.removelast;
      updown:=1;
      end
   else if (cardcursor.last.card=king) and (cardcursor.last.suit=(sender as tpile).last.suit) then
      begin
      (sender as tpile).addcard(cardcursor.last);
      cardcursor.removelast;
      updown:=-1;
      end;
   end
else if (ord(cardcursor.last.card)-ord((sender as tpile).last.card)=updown) and
        (cardcursor.last.suit=(sender as tpile).last.suit) then
      begin
      (sender as tpile).addcard(cardcursor.last);
      cardcursor.removelast;
      end;
end;

end.
