*
*  X3SETCLS.PRG
*  SET CLASSLIB to the passed .VCX
*
*  Copyright (c) 1996  (Public Domain) MaxTech, Inc. 
*                      MaxTech, Inc.
*                      8721C Plantation Lane, Suite 302
*                      Manassas, VA  20110
*                      703-369-1759
*  Author:  Drew Speedie
*
*  Usage:
*    =x3setcls("X3FWPPOP") 
*    =x3setcls("X3FW.VCX")
*    
*  lParameters
*     tcClassLib (R) Name of the .VCX class library to be added to 
*                    the SET CLASSLIB "path".  The ".VCX" extension
*                    is optional
*
* 
lParameters tcClassLib
IF type("tcClassLib") = "C" AND !empty(tcClassLib)
  tcClasslib = upper(alltrim(tcClassLib))
 ELSE
  return .f.
ENDIF
IF rightc(tcClassLib,4) = ".VCX"
 ELSE
  tcClassLib = tcClassLib + ".VCX"
ENDIF
local llSuccess
llSuccess = .t.
IF tcClassLib $ set("CLASSLIB")
 ELSE
  local lcOnError 
  lcOnError = on("ERROR")
  on error llSuccess = .f. 
  set classlib to (tcClassLib) additive
  on error &lcOnError
ENDIF
return llSuccess