
//
// MkHelp 1.0.2 cpp example
//


#include <stdio.h>
#include <iostream.h>
#include <strstream.h>
#include <fstream.h>
#ifndef _MSC_VER
#include <complex.h>
#endif
#include <algorithm>               // STL lib, MkHelp search 'algorithm.h'



/*
   This is a sample for C++ comments support with MkHelp 1.0

   Base class
*/

class MkHelp_Base
{

	int a;			// Wrong comment location for 'int a'

   // Good comment location for 'Base *fs'
	MkHelp_Base *fs;

   // contructor with 2 params
	MkHelp_Base(int a, double *m);

	public :

	MkHelp_Base &afs;

   // default constructor
	MkHelp_Base();
	int* getA(void);

   MkHelp_Base  & __cdecl operator >> (MkHelp_Base  & (__cdecl *_f)(MkHelp_Base  &));
};

/*
   This is the new MkHelp comment support ,must start with '/ * {'
   and end with '}\n* /' like this (see lower)
*/

/*{
	VERSION : 0.51
	AUTHORS : QuadByte
	COMMENT
	{
		 Base class for <b>MkHelp_graphic</b> operations
	}
   EXAMPLE
   {
      MkHelp_graphic gr = new MkHelp_graphic();
   }
}
*/


struct MkHelp_graphic : private MkHelp_Base
{
	int f(int);
	int f1(int) const;
	int f2(int) const = 0;
	int f3(int) const {}
};

